commit 48596392ea18df644a34fda84f0d58777b80c071
Author: freddy77 <freddy77>
Date:   Fri Mar 6 17:34:26 2009 +0000

    add and fix test for text

diff --git a/ChangeLog b/ChangeLog
index 41b1652..ddc36d5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Mar  6 18:34:12 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/sql2tds.c src/odbc/unittests/genparams.c:
+	- add and fix test for text
+
 Fri Mar  6 15:30:58 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/config.c: fix kerberos login with no freetds.conf
 
@@ -1381,4 +1385,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2743 2009/03/06 14:32:05 freddy77 Exp $
+$Id: ChangeLog,v 1.2744 2009/03/06 17:34:26 freddy77 Exp $
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 25a7041..152494e 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.79 2008/11/12 10:38:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.80 2009/03/06 17:34:31 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -155,6 +155,15 @@ odbc_wstr2str(TDS_STMT * stmt, const char *src, int* len)
 	return out;
 }
 
+static void
+_odbc_blob_free(TDSCOLUMN *col)
+{
+        if (!col->column_data)
+                return;
+
+        TDS_ZERO_FREE(col->column_data);
+}
+
 /**
  * Convert parameters to libtds format
  * @return SQL_SUCCESS, SQL_ERROR or SQL_NEED_DATA
@@ -348,11 +357,24 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 	case XSYBNVARCHAR:
 	case XSYBNCHAR:
 	case SYBNVARCHAR:
+	case SYBNTEXT:
+	case SYBTEXT:
 		if (!need_data && (sql_src_type == SQL_C_CHAR || sql_src_type == SQL_C_WCHAR)) {
 			if (curcol->column_data && curcol->column_data_free)
 				curcol->column_data_free(curcol);
 			curcol->column_data_free = NULL;
-			curcol->column_data = (TDS_UCHAR*) src;
+			if (dest_type == SYBNTEXT || dest_type == SYBTEXT) {
+				TDSBLOB *blob = (TDSBLOB *) calloc(1, sizeof(TDSBLOB));
+				if (!blob) {
+					odbc_errs_add(&stmt->errs, "HY001", NULL);
+					return SQL_ERROR;
+				}
+				blob->textvalue = src;
+				curcol->column_data = (TDS_UCHAR*) blob;
+				curcol->column_data_free = _odbc_blob_free;
+			} else {
+				curcol->column_data = (TDS_UCHAR*) src;
+			}
 			curcol->column_size = len;
 			curcol->column_cur_size = len;
 			return SQL_SUCCESS;
@@ -434,8 +456,9 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		if (res > curcol->column_size)
 			res = curcol->column_size;
 		break;
-	case SYBTEXT:
 	case SYBNTEXT:
+		dest_type = SYBTEXT;
+	case SYBTEXT:
 	case SYBLONGBINARY:
 	case SYBIMAGE:
 		res = tds_convert(dbc->env->tds_ctx, src_type, src, len, dest_type, &ores);
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 75a9483..fdcce26 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -12,13 +12,13 @@
  * (3) numeric -> *        different format
  * (4) *       -> numeric  take precision and scale from ipd TODO
  * (5) *       -> char     test wide
- * (6) *       -> blob     test wchar and ntext TODO
+ * (6) *       -> blob     test wchar and ntext
  * (7) *       -> binary   test also with wchar TODO
  * (8) binary  -> *        test also with wchar TODO
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.38 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.39 2009/03/06 17:34:31 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -186,7 +186,12 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 		sep = "'";
 		if (strncmp(expected, "0x", 2) == 0)
 			sep = "";
-		sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE col = CONVERT(%s, %s%s%s)", param_type, sep, expected, sep);
+		if (strcmp(param_type, "TEXT") == 0)
+			sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE CONVERT(VARCHAR(255), col) = CONVERT(VARCHAR(255), %s%s%s)", sep, expected, sep);
+		else if (strcmp(param_type, "NTEXT") == 0)
+			sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE CONVERT(NVARCHAR(2000), col) = CONVERT(NVARCHAR(2000), %s%s%s)", sep, expected, sep);
+		else
+			sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE col = CONVERT(%s, %s%s%s)", param_type, sep, expected, sep);
 		Command(sbuf);
 
 		CHKFetch("S");
@@ -218,6 +223,7 @@ AllTests(void)
 	precision = 38;
 	TestOutput("NUMERIC(18,2)", "123", SQL_C_NUMERIC, SQL_NUMERIC, "38 0 1 7B");
 	TestInput(SQL_C_LONG, "INTEGER", SQL_VARCHAR, "VARCHAR(20)", "12345");
+	TestInput(SQL_C_LONG, "INTEGER", SQL_LONGVARCHAR, "TEXT", "12345");
 	/* MS driver behavior for output parameters is different */
 	if (driver_is_freetds())
 		TestOutput("VARCHAR(20)", "313233", SQL_C_BINARY, SQL_VARCHAR, "333133323333");
@@ -277,6 +283,7 @@ AllTests(void)
 
 	TestInput(SQL_C_NUMERIC, "NUMERIC(20,3)", SQL_NUMERIC, "NUMERIC(20,3)", "765432.2 -> 765432");
 	TestInput(SQL_C_NUMERIC, "NUMERIC(20,3)", SQL_VARCHAR, "VARCHAR(20)", "578246.234 -> 578246");
+	TestInput(SQL_C_NUMERIC, "NUMERIC(20,3)", SQL_LONGVARCHAR, "TEXT", "578246.234 -> 578246");
 
 	TestInput(SQL_C_BIT, "BIT", SQL_BIT, "BIT", "0");
 	TestInput(SQL_C_BIT, "BIT", SQL_BIT, "BIT", "1");
@@ -284,9 +291,12 @@ AllTests(void)
 	TestInput(SQL_C_DOUBLE, "MONEY", SQL_DOUBLE, "MONEY", "123.34");
 
 	TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_VARCHAR, "VARCHAR(20)", "1EasyTest");
+	TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_LONGVARCHAR, "TEXT", "1EasyTest");
 	TestInput(SQL_C_WCHAR, "VARCHAR(10)", SQL_VARCHAR, "VARCHAR(10)", "Test 12345");
+	TestInput(SQL_C_WCHAR, "VARCHAR(10)", SQL_LONGVARCHAR, "TEXT", "Test 12345");
 	/* TODO use collate in syntax if available */
 	TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_VARCHAR, "VARCHAR(20)", "me\xf4");
+	TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_LONGVARCHAR, "TEXT", "me\xf4");
 
 	precision = 6;
 	/* output from char with conversions */
@@ -299,16 +309,23 @@ AllTests(void)
 		TestOutput("BIGINT", "-987654321065432", SQL_C_BINARY, SQL_BIGINT, big_endian ? "FFFC7DBBCF083228" : "283208CFBB7DFCFF");
 		TestInput(SQL_C_SBIGINT, "BIGINT", SQL_BIGINT, "BIGINT", "-12345678901234");
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "test");
+		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WLONGVARCHAR, "NTEXT", "test");
 		/* test for invalid stream due to truncation*/
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "01234567890");
+		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WLONGVARCHAR, "NTEXT", "01234567890");
 #ifdef ENABLE_DEVELOPING
 		check_truncation = 1;
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "012345678901234567890");
+		check_truncation = 1;
+		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WLONGVARCHAR, "NTEXT", "012345678901234567890");
 #endif
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "\xa3h\xf9 -> 0xA3006800f900");
+		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WLONGVARCHAR, "NTEXT", "\xa3h\xf9 -> 0xA3006800f900");
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "0xA3006800f900 -> \xa3h\xf9");
+		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WLONGVARCHAR, "NTEXT", "0xA3006800f900 -> \xa3h\xf9");
 
 		TestInput(SQL_C_LONG, "INT", SQL_WVARCHAR, "NVARCHAR(100)", "45236");
+		TestInput(SQL_C_LONG, "INT", SQL_WLONGVARCHAR, "NTEXT", "45236");
 
 		precision = 6;
 		TestOutput("NVARCHAR(20)", "foo test", SQL_C_CHAR, SQL_WVARCHAR, "6 foo te");
@@ -318,9 +335,13 @@ AllTests(void)
 		TestOutput("NVARCHAR(20)", "0xf800f900", SQL_C_CHAR, SQL_WVARCHAR, "2 \xf8\xf9");
 
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WVARCHAR, "NVARCHAR(10)", "1EasyTest2");
+		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WLONGVARCHAR, "NTEXT", "1EasyTest2");
 		use_nts = 1;
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WVARCHAR, "NVARCHAR(10)", "1EasyTest3");
+		use_nts = 1;
+		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WLONGVARCHAR, "NTEXT", "1EasyTest3");
 		TestInput(SQL_C_WCHAR, "NVARCHAR(3)", SQL_WVARCHAR, "NVARCHAR(3)", "0xf800a300bc06");
+		TestInput(SQL_C_WCHAR, "NVARCHAR(3)", SQL_WLONGVARCHAR, "NTEXT", "0xf800a300bc06");
 
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_INTEGER, "INT", " -423785  -> -423785");
 	}

